// Euphory (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int fcut2(char *_fname, int _trk, int _C, int _H, int _R, int _offset, int _size)
{
	int trk = _trk;
	int C = _C;
	int H = _H;
	int R = _R;
	int N;
	int size = 0;
	unsigned char *lp = buff;

	int m_minsec;
	int m_maxsec;
	int secsize;

	while (size < _size)
	{	
		N = ((trk>=0x16)&&(trk<=0x33)&&(R!=0x16))? 3 : 1;
		m_maxsec = ((trk>=0x16)&&(trk<=0x33))? 0x15 : 0x20;
		secsize = 0x80 << N;

		if (secsize > _size - size)	secsize = _size - size;
		if (!disk.ReadDATA1(trk, C, H, R, N, lp, secsize)) return 0;
		lp += secsize;
		size += secsize;

		// ʏ
		if ((trk==0x18*2+1) && (C==0x18) && (H==0x01) && (R==0x15))
		{
			trk = 0x19*2;
			C   = 0x19;
			H   = 0;
			R   = 0x14;
			continue;
		}
		if (R == m_maxsec) {
			trk++;
			m_minsec = ((trk<2)||(trk==4)||(trk==5))? 0x01 : 0x11;
			if (H == 0) {
				H = 1;
			} else {
				H = 0;
				C++;
			}
			R = m_minsec;
		} else {
			R++;
		}
	}
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return size;
}

struct fpos
{
	int BC;
	int size;
	char fname[FILENAME_MAX];
};

int main(int argc, char *argv[])
{

	char fname[11];
	int i,d;
	int musnum=0;

	struct fpos md[] =
	{
		{ 0x0060, 0x60, "PROG01" },
		{ 0x0110, 0x10, "DEM00F" },
		{ 0x0120, 0x10, "DEM00P" },
		{ 0x0130, 0x10, "DEM01F" },
		{ 0x0140, 0x10, "DEM01P" },
		{ 0x0183, 0x0c, "MUS00P" },
		{ 0x01a1, 0x0c, "MUS00F" },
		{ 0x01d3, 0x0c, "MUS01P" },
		{ 0x01f1, 0x0c, "MUS01F" },
		{ 0x0223, 0x0c, "MUS02P" },
		{ 0x0241, 0x0c, "MUS02F" },
		{ 0x0273, 0x0c, "MUS03P" },
		{ 0x0291, 0x0c, "MUS03F" },
		{ 0x02c3, 0x0c, "MUS04P" },
		{ 0x02e1, 0x0c, "MUS04F" },
		{ 0x0313, 0x0c, "MUS05P" },
		{ 0x0331, 0x0c, "MUS05F" },
//		{ 0x0358, 0x02, "VOICE"  },
		{ 0x0000, 0x00, "DATA_END" },
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);
	disk.SetRecordRange(0x11,0x20);
	fcut("PROG00", 0x04, 0x02, 0x00, 0x01, 0x01, 0x0000, 0x1000);
	fcut("PROG02", 0x0e, 0x07, 0x00, 0x11, 0x01, 0x0000, 0x1000);
	for (i=0; md[i].BC; i++)
	{
		fcut2(md[i].fname, (md[i].BC)>>4, md[i].BC>>5, (md[i].BC>>4)&1, ((md[i].BC)&0x0f)+0x11, 0x0000, md[i].size*0x100);
	}

	return 0;
}
